"""
    disable_polyester_threads(f::F)

A context manager function that disables Polyester threads without affecting the scheduling
of `Base.Treads.@threads`. Particularly useful for cases when Polyester has been used to
multithread an inner small problem that is now to be used in an outer embarassingly parallel
problem (in such cases it is best to multithread only at the outermost level).

This call will disable all PolyesterWeave threads, including those in
`LoopVectorization.@tturbo` and `Octavian.matmul`.

Avoid calling it as `@threads for i in 1:n disable_polyester_threads(f) end` as that creates
unnecessary per-thread overhead. Rather call it in the outermost scope, e.g. as given here:

```
disable_polyester_threads() do
    @threads for i in 1:n f()
end
```
"""
function disable_polyester_threads(f::F) where {F}
  _, r = request_threads(Threads.nthreads())
  try
    f()
  finally
    foreach(free_threads!, r)
  end
end

module PolyesterWeave
if isdefined(Base, :Experimental) &&
   isdefined(Base.Experimental, Symbol("@max_methods"))
  @eval Base.Experimental.@max_methods 1
end

using BitTwiddlingConvenienceFunctions: nextpow2
using ThreadingUtilities: _atomic_store!, _atomic_or!, _atomic_xchg!
using Static
using IfElse: ifelse

export request_threads, free_threads!

@static if VERSION ≥ v"1.6.0-DEV.674"
  @inline function assume(b::Bool)
    Base.llvmcall(
      (
        """
      declare void @llvm.assume(i1)

      define void @entry(i8 %byte) alwaysinline {
      top:
        %bit = trunc i8 %byte to i1
        call void @llvm.assume(i1 %bit)
        ret void
      }
  """,
        "entry"
      ),
      Cvoid,
      Tuple{Bool},
      b
    )
  end
else
  @inline assume(b::Bool) = Base.llvmcall(
    (
      "declare void @llvm.assume(i1)",
      "%b = trunc i8 %0 to i1\ncall void @llvm.assume(i1 %b)\nret void"
    ),
    Cvoid,
    Tuple{Bool},
    b
  )
end

const WORKERS = Ref{NTuple{8,UInt64}}(ntuple(((zero ∘ UInt64)), Val(8)))

include("unsignediterator.jl")
include("request.jl")

dynamic_thread_count() = min((Sys.CPU_THREADS)::Int, Threads.nthreads())
worker_mask_init(x) = if x < 0
    0x0000000000000000
  elseif x ≥ 64
    0xffffffffffffffff
  else
    ((0x0000000000000001 << x) - 0x0000000000000001)
  end
# function static_thread_init()
#   nt = num_threads()
#   Base.Cartesian.@ntuple 8 i -> worker_mask_init(nt - (i-1)*64)
# end
function reset_workers!()
  # workers = ntuple(((zero ∘ UInt64)), Val(8))
  nt = dynamic_thread_count() - 1
  WORKERS[] = Base.Cartesian.@ntuple 8 i -> worker_mask_init(nt - (i - 1) * 64)
end
__init__() = reset_workers!()

include("utility.jl")

end

println(
  "Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...",
)
using PolyesterWeave, Aqua
using Test

@testset "PolyesterWeave.jl" begin

  threads, torelease = PolyesterWeave.request_threads(Threads.nthreads()-1)
  @test threads isa NTuple{Int(PolyesterWeave.worker_mask_count()),PolyesterWeave.UnsignedIteratorEarlyStop{UInt}}
  @test sum(map(length, threads)) == PolyesterWeave.dynamic_thread_count()-1
  PolyesterWeave.free_threads!(torelease)

  r1 = PolyesterWeave.request_threads(Sys.CPU_THREADS, 0x0a)
  @test (r1[2][1] & 0x0a) == r1[2][1]
  r2 = PolyesterWeave.request_threads(Sys.CPU_THREADS, 0xff)
  @test (r2[2][1] & 0xff) == r2[2][1]
  @test count_ones(r1[2][1] ⊻ r2[2][1]) ≤ min(8, Sys.CPU_THREADS)
  @test iszero(r1[2][1] & r2[2][1])
  PolyesterWeave.free_threads!(r1[2]); PolyesterWeave.free_threads!(r2[2])

  @testset "Valid State" begin
    @test sum(map(count_ones, PolyesterWeave.WORKERS[])) == min(512, PolyesterWeave.dynamic_thread_count() - 1)
  end
end
Aqua.test_all(PolyesterWeave)

import CPUSummary

function worker_bits()
  wts = nextpow2(CPUSummary.sys_threads()) # Typically sys_threads (i.e. Sys.CPU_THREADS) does not change between runs, thus it will precompile well.
  ws = static(8sizeof(UInt))               # For testing purposes it can be overridden by JULIA_CPU_THREADS,
  ifelse(Static.lt(wts, ws), ws, wts)
end
function worker_mask_count()
  bits = worker_bits()
  (bits + StaticInt{63}()) ÷ StaticInt{64}() # cld not defined on `StaticInt`
end

worker_pointer() = Base.unsafe_convert(Ptr{UInt}, pointer_from_objref(WORKERS))

function free_threads!(freed_threads::U) where {U<:Unsigned}
  _atomic_or!(worker_pointer(), freed_threads)
  nothing
end
function free_threads!(freed_threads_tuple::NTuple{1,U}) where {U<:Unsigned}
  _atomic_or!(worker_pointer(), freed_threads_tuple[1])
  nothing
end
function free_threads!(freed_threads_tuple::Tuple{U,Vararg{U,N}}) where {N,U<:Unsigned}
  wp = worker_pointer()
  for freed_threads in freed_threads_tuple
    _atomic_or!(wp, freed_threads)
    wp += sizeof(UInt)
  end
  nothing
end

@inline _remaining(x::Tuple) = Base.tail(x)
@inline _remaining(@nospecialize(x)) = nothing
@inline _first(::Tuple{}) = nothing
@inline _first(x::Tuple{X,Vararg}) where {X<:Unsigned} = getfield(x, 1)
@inline _first(x::Union{Unsigned,Nothing}) = x
@inline function _request_threads(
  num_requested::UInt32,
  wp::Ptr,
  ::StaticInt{N},
  threadmask,
) where {N}
  ui, ft, num_requested, wp = __request_threads(num_requested, wp, _first(threadmask))
  uit, ftt = _request_threads(
    num_requested,
    wp,
    StaticInt{N}() - StaticInt{1}(),
    _remaining(threadmask),
  )
  (ui, uit...), (ft, ftt...)
end
@inline function _request_threads(
  num_requested::UInt32,
  wp::Ptr,
  ::StaticInt{1},
  threadmask,
)
  ui, ft, num_requested, wp = __request_threads(num_requested, wp, _first(threadmask))
  (ui,), (ft,)
end

@inline function _exchange_mask!(wp, ::Nothing)
  all_threads = _atomic_xchg!(wp, zero(UInt))
  all_threads, all_threads
end
@inline function _exchange_mask!(wp, threadmask::Unsigned)
  all_threads = _atomic_xchg!(wp, zero(UInt))
  tm = threadmask % UInt
  saved = all_threads & (~tm)
  _atomic_store!(wp, saved)
  all_threads | saved, all_threads & tm
end
@inline function __request_threads(num_requested::UInt32, wp::Ptr, threadmask)
  no_threads = zero(UInt)
  if (num_requested ≢ StaticInt{-1}()) && (num_requested % Int32 ≤ zero(Int32))
    return UnsignedIteratorEarlyStop(zero(UInt), 0x00000000), no_threads, 0x00000000, wp
  end
  # to get more, we xchng, setting all to `0`
  # then see which we need, and free those we aren't using.
  wpret = wp + 8 # (UInt === UInt64) | (worker_mask_count() === StaticInt(1)) #, so adding 8 is fine.
  # _all_threads = all_threads = _apply_mask(_atomic_xchg!(wp, no_threads), threadmask)
  _all_threads, all_threads = _exchange_mask!(wp, threadmask)
  additional_threads = count_ones(all_threads) % UInt32
  # num_requested === StaticInt{-1}() && return reserved_threads, all_threads
  if num_requested === StaticInt{-1}()
    return UnsignedIteratorEarlyStop(all_threads), all_threads, num_requested, wpret
  end
  nexcess = num_requested - additional_threads
  if signed(nexcess) ≥ 0
    return UnsignedIteratorEarlyStop(all_threads), all_threads, nexcess, wpret
  end
  # we need to return the `excess` to the pool.
  lz = leading_zeros(all_threads) % UInt32
  while true
    # start by trying to trim off excess from lz
    lz += (-nexcess) % UInt32
    m = (one(UInt) << (UInt32(8sizeof(UInt)) - lz)) - one(UInt)
    masked = (all_threads & m) ⊻ all_threads
    nexcess += count_ones(masked) % UInt32
    all_threads &= (~masked)
    nexcess == zero(nexcess) && break
  end
  _atomic_store!(wp, _all_threads & (~all_threads))
  return UnsignedIteratorEarlyStop(all_threads, num_requested),
  all_threads,
  0x00000000,
  wpret
end

@inline function request_threads(num_requested, threadmask)
  _request_threads(
    num_requested % UInt32,
    worker_pointer(),
    worker_mask_count(),
    threadmask,
  )
end
@inline request_threads(num_requested) = request_threads(num_requested, nothing)

"""
`request_threads` is called to request a set of `ThreadingUtilities` worker tasks to run on.

```
julia> using PolyesterWeave

julia> PolyesterWeave.request_threads(12)
((Thread (12) Iterator: U[1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12],), (0x0000000000000fff,))
```

This returns an iterator over the available threads 1-12
`U[1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]`, as well as a mask that must be used for freeing
these threads when done.

Note that the thread doing the requesting should also always do part of the work. Thus if
you want to run on 13 threads, you'd request 12. If you want to run on 8 threads, you'd
request 7. Etc.

If you request more threads than available on the system, you get only what is available:

```
julia> Sys.CPU_THREADS, Threads.nthreads()
(16, 8)

julia> r1 = PolyesterWeave.request_threads(30) # Note you get only 7, not 8
((Thread (7) Iterator: U[1, 2, 3, 4, 5, 6, 7],), (0x000000000000007f,))

julia> r2 = PolyesterWeave.request_threads(30)
((Thread (0) Iterator: UInt64[],), (0x0000000000000000,))
```

The following are unsupported features that might be yanked out at any time:

During request you can also mask out which threads you can get. For instance, this call:

```
julia> Sys.CPU_THREADS, Threads.nthreads()
(96, 96)

julia> r1 = PolyesterWeave.request_threads(96, 0xa)
((Thread (2) Iterator: U[2, 4], Thread (31) Iterator: U[1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31]), (0x000000000000000a, 0x000000007fffffff))
```

Is saying you want 96 threads, but you have the mask `0x0a` which turns off all threads from
the first set of 64 except for 2 and 4:

```
julia> bitstring(0xa)
"00001010"
```

Hence you got the iterator `U[2,4]`, plus an iterator over all the available works from the
next batch of 64.
"""
function request_threads end

struct UnsignedIterator{U}
  u::U
end

Base.IteratorSize(::Type{<:UnsignedIterator}) = Base.HasShape{1}()
Base.IteratorEltype(::Type{<:UnsignedIterator}) = Base.HasEltype()

Base.eltype(::UnsignedIterator) = UInt32
Base.length(u::UnsignedIterator) = count_ones(u.u)
Base.size(u::UnsignedIterator) = (count_ones(u.u),)

# @inline function Base.iterate(u::UnsignedIterator, uu = u.u)
#     tz = trailing_zeros(uu) % UInt32
#     # tz ≥ 0x00000020 && return nothing
#     tz > 0x0000001f && return nothing
#     uu ⊻= (0x00000001 << tz)
#     tz, uu
# end
@inline function Base.iterate(u::UnsignedIterator, (i, uu) = (0x00000000, u.u))
  tz = trailing_zeros(uu) % UInt32
  tz == 0x00000020 && return nothing
  i += tz
  tz += 0x00000001
  uu >>>= tz
  (i, (i + 0x00000001, uu))
end

"""
    UnsignedIteratorEarlyStop(thread_mask[, num_threads = count_ones(thread_mask)])

Iterator, returning `(i,t) = Tuple{UInt32,UInt32}`, where `i` iterates from `1,2,...,num_threads`, and `t` gives the threadids to call `ThreadingUtilities.taskpointer` with.

Unfortunately, codegen is suboptimal when used in the ergonomic `for (i,tid) ∈ thread_iterator` fashion. If you want to microoptimize,
You'd get better performance from a pattern like:

```julia
function sumk(u, l = count_ones(u) % UInt32)
  uu = ServiceSolicitation.UnsignedIteratorEarlyStop(u, l)
  s = zero(UInt32)
  state = ServiceSolicitation.initial_state(uu)
  while true
    iter = iterate(uu, state)
    iter === nothing && break
    (i, t), state = iter
    s += t
  end
  s
end
```

This iterator will iterate at least once; it's important to check and exit early with a single threaded version.
"""
struct UnsignedIteratorEarlyStop{U}
  u::U
  i::UInt32
end
UnsignedIteratorEarlyStop(u) =
  UnsignedIteratorEarlyStop(u, count_ones(u) % UInt32)
UnsignedIteratorEarlyStop(u, i) = UnsignedIteratorEarlyStop(u, i % UInt32)

mask(u::UnsignedIteratorEarlyStop) = getfield(u, :u)
Base.IteratorSize(::Type{<:UnsignedIteratorEarlyStop}) = Base.HasShape{1}()
Base.IteratorEltype(::Type{<:UnsignedIteratorEarlyStop}) = Base.HasEltype()

Base.eltype(::UnsignedIteratorEarlyStop) = Tuple{UInt32,UInt32}
Base.length(u::UnsignedIteratorEarlyStop) = getfield(u, :i)
Base.size(u::UnsignedIteratorEarlyStop) = (getfield(u, :i),)

@inline function initial_state(u::UnsignedIteratorEarlyStop)
  # LLVM should figure this out if you check?
  assume(0x00000000 ≠ u.i)
  (0x00000000, u.u)
end
@inline function iter(i, uu)
  assume(uu ≠ zero(uu))
  tz = trailing_zeros(uu) % UInt32
  tz += 0x00000001
  i += tz
  uu >>>= tz
  i, uu
end
@inline function Base.iterate(
  u::UnsignedIteratorEarlyStop,
  ((i, uu), j) = (initial_state(u), 0x00000000)
)
  # assume(u.i ≤ 0x00000020)
  # assume(j ≤ count_ones(uu))
  # iszero(j) && return nothing
  j == u.i && return nothing
  j += 0x00000001
  i, uu = iter(i, uu)
  ((j, i), ((i, uu), j))
end
function Base.show(io::IO, u::UnsignedIteratorEarlyStop)
  l = length(u)
  s = Vector{Int}(undef, l)
  if l > 0
    s .= last.(u)
  end
  print("Thread ($l) Iterator: U", s)
end

# @inline function Base.iterate(u::UnsignedIteratorEarlyStop, (i,uu) = (0xffffffff,u.u))
#     tz = trailing_zeros(uu) % UInt32
#     tz == 0x00000020 && return nothing
#     tz += 0x00000001
#     i += tz
#     uu >>>= tz
#     (i, (i,uu))
# end

using PolyesterWeave
using Documenter

DocMeta.setdocmeta!(
  PolyesterWeave,
  :DocTestSetup,
  :(using PolyesterWeave);
  recursive = true
)

makedocs(;
  modules = [PolyesterWeave],
  authors = "Chris Elrod <elrodc@gmail.com> and contributors",
  repo = "https://github.com/JuliaSIMD/PolyesterWeave.jl/blob/{commit}{path}#{line}",
  sitename = "PolyesterWeave.jl",
  format = Documenter.HTML(;
    prettyurls = get(ENV, "CI", "false") == "true",
    canonical = "https://JuliaSIMD.github.io/PolyesterWeave.jl",
    assets = String[]
  ),
  pages = ["Home" => "index.md"]
)

deploydocs(;
  repo = "github.com/JuliaSIMD/PolyesterWeave.jl",
  devbranch = "main"
)

```@meta
CurrentModule = PolyesterWeave
```

# PolyesterWeave

Documentation for [PolyesterWeave](https://github.com/JuliaSIMD/PolyesterWeave.jl).

```@index
```

```@autodocs
Modules = [PolyesterWeave]
```
